stackseg	segment stack 'stack'
	db      512 dup (?)
stackseg        ends

public    _init
public    _pset
public    _put
public    _puttran
public	_palette
public	_merge
public	_putb

before 	macro
	push bp      ;Save the base pointer
	mov bp,sp	   ;Copy the stack pointer

	push    ds   ;save the registers
	push    es
	push    si
	push    di
	endm

; Postfix -- Returns the pointers to the condition they were in when
;               the C program called the routine

after 	macro
	pop     di
	pop     si
	pop     es
	pop     ds

	mov     sp,bp   ;Restore the stack pointer
	pop     bp
	     ;Restore the base pointer
	ret             ;return from subroutine
	endm

_cdseg	segment byte public 'CODE'	;Program segment begins here
assume cs:_cdseg

;set 320*200*256 mode
_init 	proc far
	;mov ax, 4f02h
	;mov bx, 101h
	mov ax, 13h
	int 10h
	ret
_init 	endp
;---------
;put a pixel on the screen
_pset	proc far
	push    bp      ;Save the base pointer
	mov     bp,sp   ;Copy the stack pointer

	;push    ds      ;save the registers
	;push    es
	;push    si
	;push    di
	jnz hi
 hi:
;         do some bank switching
;
;	mov ax, 4f05h;
;	mov bx, 0000h
;	mov dx, 0014h;
;	int 10h
;
;
	mov ax, 0a000h 	;vga mem
	mov es, ax
	mov ax, 320	;y
	mul [bp+8]
	add ax, [bp+6]    	;x
	mov di, ax
	mov ax, [bp+10] 	;color
	mov es:[di], al


	;pop     di
	;pop     si
	;pop     es
	;pop     ds

	mov     sp,bp   ;Restore the stack pointer
	pop     bp      ;Restore the base pointer

	ret
_pset	endp
;---------
_put	proc far
	before

	mov ax, 0a000h
	mov es, ax

	mov ax, 320
	mul [bp+12]
	add ax, [bp+10]
	mov di, ax


	mov ds,[bp+8]		;Segment of image
	mov si,[bp+6]		;offset of image

	;add si, 4
	lodsw
	mov bx, ax
	lodsw
	mov cx, ax
	inc cx
	inc bx


	mov dx, 320
	sub dx, bx

 hmmm:
	push cx
	mov cx, bx
	rep movsb

	pop cx
	add di, dx
	dec cx
	jnz hmmm

	after
_put	endp

;---------
;add a small image (1st passed pointer) to the packed image (2nd passed)
;also passed is size of image and image number
_merge	proc far
	before

	mov ds,[bp+8]		;Segment of image
	mov si,[bp+6]		;offset of image
	add si, 4			;skip the size garbage

	mov es,[bp+12]		;Segment of combo
	mov di,[bp+10]		;offset of combo

	mov ax, [bp+16]		;go to appropriate insert spot
	mul word ptr[bp+14]
	add di, ax


	mov cx, [bp+14]

	rep movsb

	after
_merge	endp

;---------
;put a packed graphic on screen from scenery
;
_putb	proc far
	before

	mov ax, 0a000h
	mov es, ax

	mov ax, 320		;go to right spot on screen
	mul [bp+12]
	add ax, [bp+10]
	mov di, ax


	mov ds,[bp+8]		;Segment of image
	mov si,[bp+6]		;offset of image

	mov ax, [bp+16]		;go to appropriate image
	mov bx, [bp+14]
	mul bx

	add si,  ax

	mov bx, 16  		;set up size
	mov cx, 16

	mov dx, 320		;set up wrap
	sub dx, 16

putting:				;put image on screen
	push cx
	mov cx, bx
	rep movsb

	pop cx
	add di, dx
	dec cx
	jnz putting

	after
_putb	endp

;----------------
_puttran	proc far
	before


	mov ax, 0a000h
	mov es, ax
	mov ax, 320
	mul [bp+12]		;y value
	add ax, [bp+10]     ;x value
	mov di, ax



	mov ds,[bp+8]		;Segment of image
	mov si,[bp+6]		;offset of image

	lodsw
	mov bx, ax
	lodsw
	mov cx, ax

	inc bx
	inc cx

	mov dx, 320
	sub dx, bx


 hmm:
	push cx
	mov cx, bx
ok:
	lodsb
	cmp al, 255
	je nextone
	stosb
	dec di
nextone:
	inc di
	dec cx
	jnz ok

	pop cx
	add di, dx
	dec cx
	jnz hmm

	after
_puttran	endp
;----------------
_palette  proc far
	;lets move some color
	before
	mov ds,[bp+8]		;Segment of image
	mov si,[bp+6]		;offset of image
	mov cx, 256
well:
	mov dx, 3c8h
	mov ax, 256
	sub ax, cx
	out dx, al
	mov dx, 3c9h
	lodsb
	out dx, al
	lodsb
	out dx, al
	lodsb
	out dx, al
	dec cx
	jnz well
	after
	ret
_palette	endp
;--------------
_cdseg   	ends                   ;End code segment
	end                    ;End program
