stackseg	segment stack 'stack'
	db      512 dup (?)
stackseg        ends

public    _init
public    _pset
public    _psetb
public    _put
public    _puttran
public	_palette

before 	macro
	push bp      ;Save the base pointer
	mov bp,sp	   ;Copy the stack pointer

	push    ds   ;save the registers
	push    es
	push    si
	push    di
	endm

; Postfix -- Returns the pointers to the condition they were in when
;               the C program called the routine

after 	macro
	pop     di
	pop     si
	pop     es
	pop     ds

	mov     sp,bp   ;Restore the stack pointer
	pop     bp
	     ;Restore the base pointer
	ret             ;return from subroutine
	endm

_cdseg	segment byte public 'CODE'	;Program segment begins here
assume cs:_cdseg

;set 320*200*256 mode
_init 	proc far
	mov ax, 4f02h
	mov bx, 101h
	int 10h
	ret
_init 	endp
;---------
;put a pixel on the screen
_pset	proc far
	before
;         do some bank switching
;
	mov ax, 4f05h;
	mov bx, 0000h
	mov dx, 0000h;
	int 10h
;
;
	mov ax, 0a000h 	;vga mem
	mov es, ax
	mov ax, 640	;y
	mul [bp+8]
	add ax, [bp+6]    	;x
	mov di, ax
	mov ax, [bp+10] 	;color
	mov es:[di], al

	after
_pset	endp
;---------
;put a pixel on the screen
_psetb	proc far
	push    bp      ;Save the base pointer
	mov     bp,sp   ;Copy the stack pointer

	;push    ds      ;save the registers
	;push    es
	;push    si
	;push    di
;	jnz hi
; hi:
;         do some bank switching
;adding 5 to dx moves the display down by 32
	mov ax, 4f05h;
	mov bx, 0000h
	mov dx, 000ah;
	int 10h
;
;
	mov ax, 0a000h 	;vga mem
	mov es, ax
	mov ax, 640	;y
	mul [bp+8]
	add ax, [bp+6]    	;x
	mov di, ax
	mov ax, [bp+10] 	;color
	mov es:[di], al


	;pop     di
	;pop     si
	;pop     es
	;pop     ds

	mov     sp,bp   ;Restore the stack pointer
	pop     bp      ;Restore the base pointer

	ret
_psetb	endp
;---------
_put	proc far
	before

	mov ax, 0a000h
	mov es, ax

	mov ax, 640
	mul [bp+12]
	add ax, [bp+10]
	mov di, ax

	mov dx, 640
	sub dx, 25


	mov ds,[bp+8]		;Segment of image
	mov si,[bp+6]		;offset of image

	add si, 4

	mov bx,25
	mov cx,25
 hmmm:
	push cx
	mov cx, bx
;ok:
	rep movsb
;	jnz ok

	pop cx
	add di, dx
	dec cx
	jnz hmmm

	after
_put	endp

;----------------
_puttran	proc far
	before

;find the appropriate bank
	mov ax, [bp+12]
	mov cl, 5
	shr ax, cl
	;mov ah, 0
	mov cx, 5
	mul cx

	mov dx, ax

;adding 5 to dx moves the display down by 32
	mov ax, 4f05h;
	mov bx, 0000h
;	mov dx, 0000h
	int 10h

	mov ax, [bp+12]	;y value
	mov cl, 32          ;divide by 32
	div cl
	mov cl, ah          ;remainder
	mov ch, 0

	mov ax, 0a000h
	mov es, ax

	mov ax, 640
	mul cx		;y value
	add ax, [bp+10]     ;x value
	mov di, ax

	mov dx, 640
	sub dx, 25


	mov ds,[bp+8]		;Segment of image
	mov si,[bp+6]		;offset of image

	add si, 4

	mov bx,25
	mov cx,25
 hmm:
	push cx
	mov cx, bx
ok:
	lodsb
	cmp al, 255
	je nextone
	stosb
	dec di
nextone:
	inc di
	dec cx
	jnz ok

	pop cx
	add di, dx
	dec cx
	jnz hmm

	after
_puttran	endp
;----------------
_palette  proc far
	;lets move some color
	before
	mov ds,[bp+8]		;Segment of image
	mov si,[bp+6]		;offset of image
	mov cx, 256
well:
	mov dx, 3c8h
	mov ax, 256
	sub ax, cx
	out dx, al
	mov dx, 3c9h
	lodsb
	out dx, al
	lodsb
	out dx, al
	lodsb
	out dx, al
	dec cx
	jnz well
	after
	ret
_palette	endp
;--------------
_cdseg   	ends                   ;End code segment
	end                    ;End program
